/**
 * $Id: UMNewTabListener.java,v 1.4 2004/02/05 17:52:55 vs125812 Exp $
 * Copyright  2004 Sun Microsystems, Inc. All rights reserved. 
 * 
 * Sun Microsystems, Inc. has intellectual property rights relating to
 * technology embodied in the product that is described in this document.
 * In particular, and without limitation, these intellectual property rights
 * may include one or more of the U.S. patents listed at
 * http://www.sun.com/patents and one or more additional patents or pending
 * patent applications in the U.S. and in other countries.
 * 
 * U.S. Government Rights - Commercial software. Government users are subject
 * to the Sun Microsystems, Inc. standard license agreement and applicable
 * provisions of the FAR and its supplements.
 * 
 * Use is subject to license terms. 
 * 
 * This distribution may include materials developed by third parties. Sun,
 * Sun Microsystems, the Sun logo, Java and Sun[tm] ONE are trademarks or
 * registered trademarks of Sun Microsystems, Inc. in the U.S. and other
 * countries. 
 * 
 * Copyright  2004 Sun Microsystems, Inc. Tous droits rservs. Sun
 * Microsystems, Inc. dtient les droits de proprit intellectuels relatifs
 *  la technologie incorpore dans le produit qui est dcrit dans ce document.
 * En particulier, et ce sans limitation, ces droits de proprit
 * intellectuelle peuvent inclure un ou plus des brevets amricains lists
 *  l'adresse http://www.sun.com/patents et un ou les brevets supplmentaires
 * ou les applications de brevet en attente aux Etats - Unis et dans les
 * autres pays.
 * 
 * L'utilisation est soumise aux termes du contrat de licence.
 * 
 * Cette distribution peut comprendre des composants dvelopps par des
 * tierces parties.
 * 
 * Sun, Sun Microsystems, le logo Sun, Java et Sun[tm] ONE sont des marques
 * de fabrique ou des marques dposes de Sun Microsystems, Inc. aux
 * Etats-Unis et dans d'autres pays.
 */

package com.iplanet.am.console.user.model;

import com.iplanet.am.console.base.model.AMConsoleListenerAdapter;
import com.iplanet.am.console.base.model.AMModel;
import com.iplanet.am.sdk.AMStoreConnection;
import com.iplanet.am.util.SystemProperties;
import com.iplanet.sso.SSOException;
import com.iplanet.sso.SSOToken;

public class UMNewTabListener
    extends AMConsoleListenerAdapter
{
    public UMNewTabListener() {
    }

    /**
     * This method is called before displaying a module tab in the header view
     *
     * @param model implementation class initiates this event
     * @param moduleName   name of module
     * @return true to display this tab, false otherwises
     */
    public boolean onBeforeDisplayModuleTab(AMModel model, String moduleName) {
	boolean display = true;

	if (moduleName.equals("module105_new")) {
	    display = false;
	    SSOToken ssoToken = model.getUserSSOToken();

	    if (ssoToken != null) {
		try {
		    AMStoreConnection amStoreConn =
			new AMStoreConnection(ssoToken);
		    String userDN = ssoToken.getPrincipal().getName();
		    display = userDN.equals(SystemProperties.get(
			"com.sun.identity.authentication.super.user"));
		} catch (SSOException ssoe) {
		    // Add debug statement here
		}
	    }
	}

	return display;
    }
}
